
public class SelectionSort {
	
	public static void main(String[] args) {
		int [] A = {1,8,7,4,2,9,10} ;  //unsorted array
		int n = A.length ; //array length
		
		System.out.print("Initial array : " ) ; 
		printmyarray(A,n) ; 
		System.out.println("  " ) ; 
		
		selectionsort(A,n) ; 
		
		System.out.println("  " ) ; 
		System.out.print("The result is : " ) ; 
		printmyarray(A,n) ; 
	}
	
	
	public static void selectionsort (int A[] , int n ) {
		for(int j = n-1 ; j>=0 ; j--) {
			//find the index of the maximum in A[0 ... j]
			int k = findmaxindex(A,j) ; 
			
			//swap A[k] andA[j] 
			int x = A[j] ; 
			A[j] = A[k] ; 
			A[k] = x; 
			
			//printmyarraywithiteration(j,A,n) ; 
			
		}
	}
	
	
	public static int findmaxindex (int A[] , int j) {
		int maxindex = 0; 
		int max = Integer.MIN_VALUE ; 
		
		//we check the elements till j one by one
		for(int i =0 ; i<=j ; i++) {
			//if we find a bigger value 
			if(A[i] > max) {
				//we mark the index, and we update our max value until now
				maxindex = i ; 
				max = A[i] ;
			}
		}
		//we return the index with the max value in A[0...j]
		return maxindex ; 
	}
	
	public static int findminindex (int A[] , int j) {
		int minindex = 0; 
		int min = Integer.MAX_VALUE ; 
		
		//we check the elements till j one by one
		for(int i =0 ; i<=j ; i++) {
			//if we find a smaller value 
			if(A[i] < min) {
				//we mark the index, and we update our max value until now
				minindex = i ; 
				min = A[i] ;
			}
		}
		//we return the index with the min value in A[0...j]
		return minindex ; 
	}
	
	
	public static void printmyarraywithiteration (int iteration, int A[] , int n) {
		System.out.print("Iteration: " + iteration + "      ");
		
		System.out.print("[ ");
		for(int i = 0 ; i<n ; i++) {
			System.out.print(A[i] + " " );
		}
		
		System.out.println("]");
	}
	
	public static void printmyarray ( int A[] , int n) {
		
		System.out.print("[");
		for(int i = 0 ; i<n ; i++) {
			System.out.print(A[i] + " " );
		}
		
		System.out.println("]");
	}

}
