
public class InsertionSort {
	
	public static void main(String[] args) {
		int [] A = {5,3,7,1,4} ;  //unsorted array
		int n = A.length ; //array length
		
		System.out.print("Initial array : " ) ; 
		printmyarray(A,n) ; 
		System.out.println("  " ) ; 
		
		insertionsort(A,n) ; 
		
		System.out.println("  " ) ; 
		System.out.print("The result is : " ) ; 
		printmyarray(A,n) ; 
	}
	
	public static void insertionsort (int A[] , int n ) {
		for(int j = 1 ; j<n ; j++) {
			int k = findindexk(A,j) ;
			
			//mark A[j]  , shift elements after k 
			int x = A[j] ;
			for(int i = j-1 ; i>= k ;  i--) {
				A[i+1] = A[i] ; 
			}
			//place A[j] to the right position , which is k ;
            A[k] = x; 
            
          //printmyarraywithiteration(j,A,n) ; 
		}
	}
	
	//k ← smallest Index in {1, . . . , j − 1} with A[j] ≤ A[k]
	public static int findindexk (int A[] , int j) {
		int i = 0;
		for(i =0 ; i<=j-1 ; i++) {
			if(A[i] >= A[j]) {
				return i ; 
			}
		}
		return i ; 
	}
	
	public static void printmyarraywithiteration (int iteration, int A[] , int n) {
		System.out.print("Iteration: " + iteration + "      ");
		
		System.out.print("[ ");
		for(int i = 0 ; i<n ; i++) {
			System.out.print(A[i] + " " );
		}
		
		System.out.println("]");
	}
	
	public static void printmyarray ( int A[] , int n) {
		
		System.out.print("[");
		for(int i = 0 ; i<n ; i++) {
			System.out.print(A[i] + " " );
		}
		
		System.out.println("]");
	}

}
